import java.nio.*;
import java.nio.channels.*;
import java.io.*;

public class FileChannelTest2 {

    public FileChannelTest2(String srcFilename, String destFilename) {
        System.out.println("ǂ̕@ŃRs[܂");
        System.out.println("1: Rs[Ƀ}bv 2: Rs[Ƀ}bv");
        System.out.print("> ");
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));

        try{
            String inputText = reader.readLine();

            if (inputText.equals("1")) {
                copyUsingMappedByteBuffer1(srcFilename, destFilename);
            }else if (inputText.equals("2")) {
                copyUsingMappedByteBuffer2(srcFilename, destFilename);
            }
        }catch(IOException ex){
            ex.printStackTrace();
        }
    }

    private void copyUsingMappedByteBuffer1(String srcFilename,
                                            String destFilename){
        System.out.println("Rs[t@CɃ}bvăRs[s܂");

        try{
            FileInputStream in = new FileInputStream(srcFilename);
            FileChannel inputChannel = in.getChannel();

            FileOutputStream out = new FileOutputStream(destFilename);
            FileChannel outputChannel = out.getChannel();

            ByteBuffer buffer = inputChannel.map(FileChannel.MapMode.READ_ONLY, 0,
                                                 (int)inputChannel.size());
            outputChannel.write(buffer);

            outputChannel.close();
            inputChannel.close();

        }catch(FileNotFoundException ex){
            ex.printStackTrace();
        }catch(IOException ex){
            ex.printStackTrace();
        }
    }

    private void copyUsingMappedByteBuffer2(String srcFilename,
                                            String destFilename){
        System.out.println("Rs[t@CɃ}bvăRs[s܂");

        try{
            FileInputStream in = new FileInputStream(srcFilename);
            FileChannel inputChannel = in.getChannel();

            RandomAccessFile out = new RandomAccessFile(destFilename, "rw");
            FileChannel outputChannel = out.getChannel();

            MappedByteBuffer buffer = outputChannel.map(FileChannel.MapMode.READ_WRITE,
                                               0, (int)inputChannel.size());
            inputChannel.read(buffer);
            buffer.force();

            outputChannel.close();
            inputChannel.close();

        }catch(FileNotFoundException ex){
            ex.printStackTrace();
        }catch(IOException ex){
            ex.printStackTrace();
        }
    }

    public static void main(String[] args){
        new FileChannelTest2(args[0], args[1]);
    }
}
